<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: dashboard.php 75 2010-04-01 19:40:08Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

route_request();

function route_request(){

	// add some dashboards for the user if they don't have any
	add_default_dashboards();

	$id=grab_request_var("id","");
	if($id!=""){
		$d=get_dashboard_by_id(0,$id);
		if($d!=null){
			display_dashboard($d);
			return;
			}
		else
			display_bad_dashboard($id);
		}
	else{
		display_first_dashboard();
		}
	return;
	}

function display_no_dashboards(){
	global $lstr;
?>
<html>
<head>
	<title><?php echo $lstr['MyDashboardsPageTitle'];?></title>
	<meta name="ROBOTS" content="NOINDEX, NOFOLLOW">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php do_page_head_links();?>
</head>
<body >

<h1><?php echo $lstr['NoDashboardsDefinedPageHeader'];?></h1>

<p>
<?php echo $lstr['NoDashboardsDefinedText'];?>
</p>
	
</body>
</html>
<?php
	}
	
function display_bad_dashboard($id){
	global $lstr;
?>
<html>
<head>
	<title><?php echo $lstr['BadDashboardPageTitle'];?></title>
	<meta name="ROBOTS" content="NOINDEX, NOFOLLOW">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php do_page_head_links();?>
</head>
<body >

<h1><?php echo $lstr['BadDashboardPageHeader'];?></h1>

<p>
<?php echo $lstr['BadDashboardText'];?>  Dashboard ID: <?php echo $id;?>
</p>
	
</body>
</html>
<?php
	}
	
function display_first_dashboard(){
	$dashboards=get_dashboards(0);
	display_dashboard($dashboards[0]);
	}
	
function display_dashboard($dashboard){



	$s="";
	if(array_key_exists("opts",$dashboard)){
		if(!is_array($dashboard["opts"]))
			$dashboard["opts"]=array();
		if(array_key_exists("background",$dashboard["opts"]))
			$s="background: #".$dashboard["opts"]["background"].";";
		}
	
	do_page_start(
		array(
			"body_id" => "dashboard-".$dashboard["id"],
			"body_class" => "dashboard dashboard-".$dashboard["id"],
			"body_style" => $s,
			"page_id" => "dashboards-page".$dashboard["id"],
			"page_class" => "dashboard dashboard-".$dashboard["id"],
			"page_title" => "Dashboard - ".$dashboard["title"],
			),
		true
		);

	//echo "DASHBOARD: <BR>";
	//print_r($dashboard);
	//echo "STYLE: $s<BR>";
	
	display_dashboard_dashlets($dashboard);
	
	do_page_end(true);

	}
	

?>

