<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: index.php 120 2010-05-28 19:51:56Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();

route_request();

function route_request(){
	global $request;
	
	add_user_dashboards_to_dashboards_menu();
	
	draw_page();
	}

function draw_page(){
	global $lstr;
	
	do_page_start(array("page_id"=>"mydashboards-page","page_title"=>$lstr['DashboardsPageTitle']),false);
?>
	<div id="leftnav">
	<?php print_menu(MENU_DASHBOARDS);?>
	</div>
	
	<div id="mydashboardsinit"></div>
	<div id="mydashboardsdashboardtitle">Untitled Dashboard</div>

	<div id="maincontent">
	<iframe src="dashboard.php" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</iframe>
	<div id="viewtools">

	<div id="popout">
	<a href="#"><img src="<?php echo get_base_url();?>/images/popout.png" border="0" alt="<?php echo $lstr['PopoutAlt'];?>" title="<?php echo $lstr['PopoutAlt'];?>"></a>
	</div>
	<div id="addtomyviews">
	<a href="#"><img src="<?php echo get_base_url();?>/images/addtomyviews.png" border="0" alt="<?php echo $lstr['AddToMyViewsAlt'];?>" title="<?php echo $lstr['AddToMyViewsAlt'];?>"></a>
	</div>

	<div id="trashdashboard">
	<a href="#"><img src="<?php echo get_base_url();?>/images/trash.png" border="0" alt="<?php echo $lstr['DeleteDashboardAlt'];?>" title="<?php echo $lstr['DeleteDashboardAlt'];?>"></a>
	</div>

	<div id="editdashboard">
	<a href="#"><img src="<?php echo get_base_url();?>/images/edit.png" border="0" alt="<?php echo $lstr['EditDashboardAlt'];?>" title="<?php echo $lstr['EditDashboardAlt'];?>"></a>
	</div>

	<div id="clonedashboard">
	<a href="#"><img src="<?php echo get_base_url();?>/images/clonedashboard.png" border="0" alt="<?php echo $lstr['CloneDashboardAlt'];?>" title="<?php echo $lstr['CloneDashboardAlt'];?>"></a>
	</div>

	</div>
	</div>

<?php	
	do_page_end(false);
	}
	
function add_user_dashboards_to_dashboards_menu(){

	// get all user dashboards
	$dashboards=get_dashboards(0);
	$x=0;
	
	foreach($dashboards as $d){
	
		$x++;
	
		add_menu_item(MENU_DASHBOARDS,array(
			"type" => "link",
			"title" => $d["title"],
			"order" => (200+$x),
			"opts" => array(
				"href" => "dashboard.php?id=".$d["id"],
				"class" => "mydashboardlink",
				"id" => "dashboard-".$d["id"],
				)
			));
		}
	}
	
?>


