<?php
// Fusion Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-sysstat.inc.php 18 2010-07-08 20:21:34Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	

////////////////////////////////////////////////////////////////////////
// SYSSTAT AJAX FUNCTIONS
////////////////////////////////////////////////////////////////////////



function fusioncore_ajax_get_stat_bar_html($rawval,$label,$displayval,$mult=20,$maxval=200,$level2=10,$level3=50){

	$val=(floatval($rawval) * $mult);
	if($val>$maxval)
		$val=$maxval;
	if($val<=1)
		$val=1;		
	else if($val<=0)
		$val=0;
	
	$spanval="0,$maxval,$val";
	
	if($val>$level3)
		$spanval="<div style='height: 10px; width: ".$val."px; background-color:  ".COMMONCOLOR_RED.";'>&nbsp;</div>";
	else if($val>$level2)
		$spanval="<div style='height: 10px; width: ".$val."px; background-color:  ".COMMONCOLOR_YELLOW.";'>&nbsp;</div>";
	else
		$spanval="<div style='height: 10px; width: ".$val."px; background-color:  ".COMMONCOLOR_GREEN.";'>&nbsp;</div>";
	
	$barclass="";
	
	$output='<tr><td><span class="sysstat_stat_subtitle">'.$label.'</span></td><td>'.$displayval.'</td><td><span class="statbar'.$barclass.'">'.$spanval.'</span></td></tr>';
	
	return $output;
	}

	
function fusioncore_ajax_get_server_stats_html($args=null){
	global $lstr;

	if(is_admin()==false)
		return $lstr['NotAuthorizedErrorText'];


	// get sysstat data
	//$xml=get_backend_xml_sysstat_data();
	$xml=get_xml_sysstat_data();
	//print_r($xml);
	
	//echo "ARGS2\n";
	//print_r($args);
	
	$id=random_string(6);
	
	$output='';
	$output.='<div class="infotable_title">Server Statistics</div>';
	if($xml==null){
		$output.="No data";
		}
	else{
		$output.='
		<table class="infotable">
		<thead>
		<tr><th><div style="width: 75px;">Metric</div></th><th><div style="width: 60px;">Value</div></th><th><div style="width: 105px;"></div></th></tr>
		</thead>
		<tbody>
		';
		
		$output.='<tr><td><span class="sysstat_stat_title">Load</span></td></tr>';
		// load 1
		$output.=fusioncore_ajax_get_stat_bar_html($xml->load->load1,"1-min",$xml->load->load1,10,100,25,75);
		// load 5
		$output.=fusioncore_ajax_get_stat_bar_html($xml->load->load5,"5-min",$xml->load->load5,10,100,25,75);
		// load 15
		$output.=fusioncore_ajax_get_stat_bar_html($xml->load->load15,"15-min",$xml->load->load15,10,100,25,75);
		
		
		$output.='<tr><td><span class="sysstat_stat_title">CPU Stats</span></td></tr>';
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->user,"User",$xml->iostat->user."%",1,100,75,95);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->nice,"Nice",$xml->iostat->nice."%",1,100,75,95);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->system,"System",$xml->iostat->system."%",1,100,75,95);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->iowait,"I/O Wait",$xml->iostat->iowait."%",1,100,5,15);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->steal,"Steal",$xml->iostat->steal."%",1,100,5,15);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->iostat->idle,"Idle",$xml->iostat->idle."%",1,100,100,100);


		$output.='<tr><td><span class="sysstat_stat_title">Memory</span></td></tr>';
		$total=intval($xml->memory->total);
		$output.='<tr><td><span class="sysstat_stat_subtitle">Total</div></td><td>'.$xml->memory->total.' MB</td></tr>';
		$t=intval($xml->memory->used);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->memory->used,"Used",get_formatted_number($xml->memory->used,0)." MB",(1/$total)*100,100,98,99);
		$t=intval($xml->memory->free);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->memory->free,"Free",get_formatted_number($xml->memory->free,0)." MB",(1/$total)*100,100,101,101);
		$t=intval($xml->memory->shared);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->memory->shared,"Shared",get_formatted_number($xml->memory->shared,0)." MB",(1/$total)*100,100,101,101);
		$t=intval($xml->memory->buffers);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->memory->buffers,"Buffers",get_formatted_number($xml->memory->buffers,0)." MB",(1/$total)*100,100,101,101);
		$t=intval($xml->memory->cached);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->memory->cached,"Cached",get_formatted_number($xml->memory->cached,0)." MB",(1/$total)*100,100,101,101);

		$output.='<tr><td><span class="sysstat_stat_title">Swap</span></td></tr>';
		$total=intval($xml->swap->total);
		$output.='<tr><td><span class="sysstat_stat_subtitle">Total</td></td><td>'.get_formatted_number($xml->swap->total,0).' MB</td></tr>';
		$t=intval($xml->swap->used);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->swap->used,"Used",get_formatted_number($xml->swap->used,0)." MB",(1/$total)*100,100,50,80);
		$t=intval($xml->swap->free);
		$output.=fusioncore_ajax_get_stat_bar_html($xml->swap->free,"Free",get_formatted_number($xml->swap->free,0)." MB",(1/$total)*100,100,100,100);


		$output.='
		</tbody>
		</table>';

		}
		
	$output.='
	<div class="ajax_date">Last Updated: '.get_datetime_string(time()).'</div>
	';
	
	return $output;
	}
	
	

	
	
?>