// $Id: dashboards.js 6 2009-11-14 20:58:01Z egalstad $

// make sure jQuery doesn't conflict with prototype, etc.
//jQuery.noConflict();

///////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
///////////////////////////////////////////////////////////////

var currentdashboardid="0";
var currentdashboardtitle="";


///////////////////////////////////////////////////////////////
// DOCUMENT LOAD FUNCTIONS
///////////////////////////////////////////////////////////////

$(document).ready(function(){
// The document is loaded and ready.  Code goes here...

	// "my dashboards" init
	$("#mydashboardsinit").each(function(){
		show_new_dashboard(0);
		});

	$("#mydashboards-page #leftnav a:not(a.mydashboardlink)").each(function(){
		$(this).click(function(){
			clear_dashboard_controls();
			update_dashboards_menu();
			unhighlight_dashboards_menu_items();
			});
		});

	$("a.mydashboardlink").click(function(){
		//alert('click');
		handle_dashboard_menu_click(this);
		return;
		});

	///////////////////////////////////////////////////////////////////////////////
	// ADD DASHBOARD
	///////////////////////////////////////////////////////////////////////////////
	$("a.addnewdashboardlink").click(function(){

		show_parent_content_throbber();
		
		var backgroundcolor="ffffff";

		var theurl="";
		var txtHeader=get_language_string("AddDashboardHeader");
		var txtMessage=get_language_string("AddDashboardMessage");
		var t1=get_language_string("AddDashboardTitleBoxTitle");
		var t2=get_language_string("DashboardBackgroundColorTitle");
		var txtSubmitButton=get_language_string("SubmitButton");
		
		var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div><form id='adddashboard_form' method='get' action='"+ajax_helper_url+"'><input type='hidden' name='cmd' value='adddashboard'><input type='hidden' name='opts' value=''><label for='adddashboardTitleBox'>"+t1+"</label><br class='nobr' /><input type='text' size='30' name='title' id='adddashboardTitleBox' value='' class='textfield' /><br class='nobr' /><label for='backgroundcolor'>"+t2+"</label><input type='hidden' name='background' value='"+backgroundcolor+"' id='backgroundcolor'><div id='colorpickerHolder2'><div id='colorSelector2'><div style='background-color: #"+backgroundcolor+";'></div></div></div><br class='nobr' /><div id='adddashboardFormButtons'><input type='submit' class='submitbutton' name='submitButton' value='"+txtSubmitButton+"' id='submitAddDashboardButton'></div></form>";

		hide_parent_content_throbber();
		set_popup_content(content);
		display_popup();
		
		$("#colorSelector2").ColorPicker({
			onSubmit: function(hsb, hex, rgb, el) {
				var x=1;
				$("#backgroundcolor").val(hex);
				$(el).val(hex);
				$(el).ColorPickerHide();
				$('#colorSelector2 div').css('backgroundColor', '#' + hex);
				},
			onBeforeShow: function () {
				var y=1;
				$(this).ColorPickerSetColor($("#backgroundcolor").val());
				},
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
				},
			onHide: function (colpkr) {
				$(colpkr).fadeOut(500);
				return false;
				},
			onChange: function (hsb, hex, rgb) {
				$("#backgroundcolor").val(hex);
				$('#colorSelector2 div').css('backgroundColor', '#' + hex);
				}
			});


		$("#adddashboard_form").submit(function(){
			hide_throbber();
			var params = {};
			$(this) 
				.find(":input, :password, :checkbox, :radio, :submit, :reset")
				.each(function(){ 
					params[ this.name || this.id || this.parentNode.name || this.parentNode.id ] = this.value;
					});
			params["nsp"]=nsp_str;
		
			$.ajax({
				type: "POST",
				url: this.getAttribute("action"),
				data: params,
				beforeSend: function(XMLHttpRequest){
					$("#popup_container").each(function(){
						this.origHTML=this.innerHTML;
						txtHeader=get_language_string("AjaxSendingHeader");
						txtMessage=get_language_string("AjaxSendingMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p><div id='popup_throbber'></div></div>";
						});
					},
				success: function(msg){
					$("#popup_container").each(function(){
						txtHeader=get_language_string("AddDashboardSuccessHeader");
						txtMessage=get_language_string("AddDashboardSuccessMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";

						update_dashboards_menu();
						fade_popup("green");
						if(currentdashboardid=="nodashboardid")
							show_new_dashboard(0);
						});
					},
				error: function(msg){
					$("#popup_container").each(function(){
						txtHeader=get_language_string("AjaxErrorHeader");
						txtMessage=get_language_string("AjaxErrorMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";
						});
					}
				});
				
			return false;
			});
		});		


	///////////////////////////////////////////////////////////////////////////////
	// EDIT DASHBOARD
	///////////////////////////////////////////////////////////////////////////////
	$("#editdashboard").click(function(){

		show_parent_content_throbber();

		var viewdata=get_ajax_data("getdashboardbyid",currentdashboardid);
		eval('var viewobj='+viewdata);

		var id=currentdashboardid;
		var title=currentdashboardtitle;
		var backgroundcolor=viewobj.background;
		
		if(currentdashboardid=="nodashboardid"){
			var txtHeader=get_language_string("NoDashboardsToEditHeader");
			var txtMessage=get_language_string("NoDashboardsToEditMessage");
			var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";
			hide_parent_content_throbber();
			set_popup_content(content);
			display_popup();
			fade_popup("red");
			return;
			}
		
		var txtHeader=get_language_string("EditDashboardHeader");
		var txtMessage=get_language_string("EditDashboardMessage");
		var t1=get_language_string("EditDashboardTitleBoxTitle");
		var t2=get_language_string("DashboardBackgroundColorTitle");
		var txtSubmitButton=get_language_string("SubmitButton");

		var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div><form id='editdashboard_form' method='get' action='"+ajax_helper_url+"'><input type='hidden' name='cmd' value='updatedashboard'><input type='hidden' name='id' value='"+id+"'><input type='hidden' name='opts' value=''><label for='editdashboardTitleBox'>"+t1+"</label><br class='nobr' /><input type='text' size='30' name='title' id='editdashboardTitleBox' value='"+title+"' class='textfield' /><br class='nobr' /><label for='backgroundcolor'>"+t2+"</label><input type='hidden' name='background' value='"+backgroundcolor+"' id='backgroundcolor'><div id='colorpickerHolder2'><div id='colorSelector2'><div style='background-color: #"+backgroundcolor+";'></div></div></div><br class='nobr' /><div id='editdashboardFormButtons'><input type='submit' class='submitbutton' name='submitButton' value='"+txtSubmitButton+"' id='submitEditDashboardButton'></div></form>";

		hide_parent_content_throbber();
		set_popup_content(content);
		display_popup();

		$("#colorSelector2").ColorPicker({
			onSubmit: function(hsb, hex, rgb, el) {
				var x=1;
				$("#backgroundcolor").val(hex);
				$(el).val(hex);
				$(el).ColorPickerHide();
				$('#colorSelector2 div').css('backgroundColor', '#' + hex);
				},
			onBeforeShow: function () {
				var y=1;
				$(this).ColorPickerSetColor($("#backgroundcolor").val());
				},
			onShow: function (colpkr) {
				$(colpkr).fadeIn(500);
				return false;
				},
			onHide: function (colpkr) {
				$(colpkr).fadeOut(500);
				return false;
				},
			onChange: function (hsb, hex, rgb) {
				$("#backgroundcolor").val(hex);
				$('#colorSelector2 div').css('backgroundColor', '#' + hex);
				}
			});

			
		$("#editdashboard_form").submit(function(){
			hide_throbber();
			var params = {};
			$(this) 
				.find(":input, :password, :checkbox, :radio, :submit, :reset")
				.each(function(){ 
					params[ this.name || this.id || this.parentNode.name || this.parentNode.id ] = this.value;
					});
		
			params["nsp"]=nsp_str;

			$.ajax({
				type: "POST",
				url: this.getAttribute("action"),
				data: params,
				beforeSend: function(XMLHttpRequest){
					$("#popup_container").each(function(){
						this.origHTML=this.innerHTML;
						txtHeader=get_language_string("AjaxSendingHeader");
						txtMessage=get_language_string("AjaxSendingMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p><div id='popup_throbber'></div></div>";
						});
					},
				success: function(msg){
					$("#popup_container").each(function(){
						txtHeader=get_language_string("EditDashboardSuccessHeader");
						txtMessage=get_language_string("EditDashboardSuccessMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";

						// adjust background color - doesnt work because dashboard is in child iframe, so we have to reload the dashboard
						//alert("DID: "+currentdashboardid);
						var id=currentdashboardid;
						show_new_dashboard_id(id);
						
						//update_dashboards_menu();
						fade_popup("green");

						});
					},
				error: function(msg){
					$("#popup_container").each(function(){
						txtHeader=get_language_string("AjaxErrorHeader");
						txtMessage=get_language_string("AjaxErrorMessage");
						this.innerHTML="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";
						});
					}
				});
				
			return false;
			});
		});

	///////////////////////////////////////////////////////////////////////////////
	// DELETE DASHBOARD
	///////////////////////////////////////////////////////////////////////////////
	$("#trashdashboard").click(function(){

		show_parent_content_throbber();

		var id=currentdashboardid;

		if(currentdashboardid=="home"){
			var txtHeader=get_language_string("CannotDeleteHomepageDashboardHeader");
			var txtMessage=get_language_string("CannotDeleteHomepageDashboardMessage");
			var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";
			hide_parent_content_throbber();
			set_popup_content(content);
			display_popup();
			fade_popup("red",2000);
			return;
			}
		
		if(currentdashboardid=="nodashboardid"){
			var txtHeader=get_language_string("NoDashboardsToDeleteHeader");
			var txtMessage=get_language_string("NoDashboardsToDeleteMessage");
			var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>";
			hide_parent_content_throbber();
			set_popup_content(content);
			display_popup();
			fade_popup("red",2000);
			return;
			}
		

		var txtHeader=get_language_string("DeleteDashboardHeader");
		var txtMessage=get_language_string("DeleteDashboardMessage");
		var txtDeleteButton=get_language_string("DeleteButton");
		var txtCancelButton=get_language_string("CancelButton");
		
		var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div><form id='deletedashboard_form' method='get' action='"+ajax_helper_url+"'><input type='hidden' name='cmd' value='deletedashboardbyid'><input type='hidden' name='opts' value='"+id+"'><br class='nobr' /><div id='editdashboardFormButtons'><input type='submit' class='submitbutton' name='submitButton' value='"+txtDeleteButton+"' id='submitDeleteDashboardButton'><!--<input type='submit' class='submitbutton' name='cancelButton' value='"+txtCancelButton+"' id='cancelDeleteDashboardButton'>--></div></form>";

		hide_parent_content_throbber();
		set_popup_content(content);
		display_popup();

		$("#deletedashboard_form").submit(function(){
			hide_throbber();
			var params = {};
			$(this) 
				.find(":input, :password, :checkbox, :radio, :submit, :reset")
				.each(function(){ 
					params[ this.name || this.id || this.parentNode.name || this.parentNode.id ] = this.value;
					});
		
			params["nsp"]=nsp_str;

			$.ajax({
				type: "POST",
				url: this.getAttribute("action"),
				data: params,
				beforeSend: function(XMLHttpRequest){
					txtHeader=get_language_string("AjaxSendingHeader");
					txtMessage=get_language_string("AjaxSendingMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p><div id='popup_throbber'></div></div>");
					},
				success: function(msg){
					txtHeader=get_language_string("DeleteDashboardSuccessHeader");
					txtMessage=get_language_string("DeleteDashboardSuccessMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>");

					fade_popup("red");
					update_dashboards_menu();
					show_new_dashboard(0);
					//close_popup();
					},
				error: function(msg){
					txtHeader=get_language_string("AjaxErrorHeader");
					txtMessage=get_language_string("AjaxErrorMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>");
					}
				});
				
			return false;
			});
		}); // delete dashboard		

	///////////////////////////////////////////////////////////////////////////////
	// CLONE DASHBOARD
	///////////////////////////////////////////////////////////////////////////////
	$("#clonedashboard").click(function(){

		show_parent_content_throbber();

		var id=currentdashboardid;
		var title=currentdashboardtitle+" (Clone)";

		var txtHeader=get_language_string("CloneDashboardHeader");
		var txtMessage=get_language_string("CloneDashboardMessage");
		var txtCloneButton=get_language_string("CloneButton");
		var txtCancelButton=get_language_string("CancelButton");
		var t1=get_language_string("CloneDashboardTitleBoxTitle");
		
		var content="<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div><form id='clonedashboard_form' method='get' action='"+ajax_helper_url+"'><input type='hidden' name='cmd' value='clonedashboardbyid'><input type='hidden' name='opts' value='"+id+"'><br class='nobr' /><label for='clonedashboardTitleBox'>"+t1+"</label><br class='nobr' /><input type='text' size='30' name='title' id='clonedashboardTitleBox' value='"+title+"' class='textfield' /><br class='nobr' /><div id='clonedashboardFormButtons'><input type='submit' class='submitbutton' name='submitButton' value='"+txtCloneButton+"' id='submitCloneDashboardButton'><!--<input type='submit' class='submitbutton' name='cancelButton' value='"+txtCancelButton+"' id='cancelCloneDashboardButton'>--></div></form>";

		hide_parent_content_throbber();
		set_popup_content(content);
		display_popup();

		$("#clonedashboard_form").submit(function(){
			hide_throbber();
			var params = {};
			$(this) 
				.find(":input, :password, :checkbox, :radio, :submit, :reset")
				.each(function(){ 
					params[ this.name || this.id || this.parentNode.name || this.parentNode.id ] = this.value;
					});
		
			params["nsp"]=nsp_str;

			$.ajax({
				type: "POST",
				url: this.getAttribute("action"),
				data: params,
				beforeSend: function(XMLHttpRequest){
					txtHeader=get_language_string("AjaxSendingHeader");
					txtMessage=get_language_string("AjaxSendingMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p><div id='popup_throbber'></div></div>");
					},
				success: function(msg){
					txtHeader=get_language_string("CloneDashboardSuccessHeader");
					txtMessage=get_language_string("CloneDashboardSuccessMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>");

					fade_popup("green");
					update_dashboards_menu();
					show_new_dashboard(0);
					//close_popup();
					},
				error: function(msg){
					txtHeader=get_language_string("AjaxErrorHeader");
					txtMessage=get_language_string("AjaxErrorMessage");
					set_popup_content("<div id='popup_header'><b>"+txtHeader+"</b></div><div id='popup_data'><p>"+txtMessage+"</p></div>");
					}
				});
				
			return false;
			});
		}); // clone dashboard		
		
 });

 
///////////////////////////////////////////////////////////////
// DASHBOARD FUNCTIONS
///////////////////////////////////////////////////////////////

function update_dashboards_menu(){
	var html=get_ajax_data("getdashboardsmenuhtml","");
	$("#mydashboardsmenu")[0].innerHTML=html;
	reinit_dashboards_menu();
	}
	
function handle_dashboard_menu_click(obj){
	var theparent=obj.parentNode;
	var url=obj.href;
	var title=obj.innerHTML;
	var rawid=obj.id;
	var id=rawid.substr(10);

	fill_dashboard_screen(title,url,id);
	var x=1;
	return;
	}
	
function fill_dashboard_screen(title,url,id,background){
	update_dashboards_menu();
	//alert('fill1');
	highlight_dashboards_menu_item("dashboard-"+id);
	//alert('fill2');
	$("#trashdashboard").css("visibility","visible");
	$("#editdashboard").css("visibility","visible");
	$("#clonedashboard").css("visibility","visible");
	//var thetarget=$("#mydashboardsviewtitle");
	//$("#dashboardsviewtitle")[0].innerHTML=title;
	//alert("FSD: ID="+id+", URL="+url);
	$("#maincontentframe").attr({src: url});
	//$("body").css("background","+"+background);  // this breaks IE!
	//alert('fill3');
	currentdashboardid=id;
	currentdashboardtitle=title;
	//alert('fill4');
	}
	
function show_new_dashboard(num){
	//alert('show');
	var viewdata=get_ajax_data("getdashboardbynum",num);
	eval('var viewobj='+viewdata);
	fill_dashboard_screen(viewobj.title,viewobj.url,viewobj.id,viewobj.background);
	currentdashboardnum=num;
	}
	
function show_new_dashboard_id(id){
	//alert("SNDID: "+id)
	var viewdata=get_ajax_data("getdashboardbyid",id);
	eval('var viewobj='+viewdata);
	fill_dashboard_screen(viewobj.title,viewobj.url,viewobj.id,viewobj.background);
	currentdashboardnum=viewobj.number;
	}

	
function clear_dashboard_controls(){
	$("#trashdashboard").css("visibility","hidden");
	$("#editdashboard").css("visibility","hidden");
	$("#clonedashboard").css("visibility","hidden");
	}

function highlight_dashboards_menu_item(id){
	$("#"+id).addClass("activemenulink");
	}

function unhighlight_dashboards_menu_items(){
	$("#mydashboards-page #leftnav a.mydashboardlink").removeClass("activemenulink");
	}

function reinit_dashboards_menu(){
	$("a.mydashboardlink").click(function(){
		handle_dashboard_menu_click(this);
		return;
		});
	}

	
	
	
