<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-dashboards.inc.php 157 2010-06-11 20:53:39Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');


function get_dashboard_dashlet_object($userid=0,$dashletid){

	$dashboards=array();
	$dashboardsraw=get_user_meta($userid,"dashboards");
	if($dashboardsraw!=null)
		$dashboards=unserialize($dashboardsraw);
	$n=0;
	foreach($dashboards as $db){
		if(array_key_exists("dashlets",$db)==true){
			$dashlets=$db["dashlets"];
			foreach($dashlets as $dnum => $dashlet){
				if($dashlet["id"]==$dashletid){
					//echo "FOUND DASHLET ID $dashletid! [$dnum]<BR>";
					return $dashboards[$n]["dashlets"][$dnum];
					}
				}
			}
		$n++;
		}
	return null;
	}


function set_dashboard_dashlet_property($userid=0,$boardid,$dashletid,$props){

	echo "SETTING DASHLET PROPERTY: BOARD=$boardid, DASHLET=$dashletid, PROPS=".serialize($props)."\n";

	$dashboards=get_dashboards($userid);
	$n=0;
	foreach($dashboards as $db){
		if($db["id"]==$boardid){
			echo "FOUND BOARD ID $boardid! [$n]<BR>";
			if(array_key_exists("dashlets",$db)==true){
				$dashlets=$db["dashlets"];
				foreach($dashlets as $dnum => $dashlet){
					if($dashlet["id"]==$dashletid){
						echo "FOUND DASHLET ID $dashletid! [$dnum]<BR>";
						foreach($props as $propvar => $propval){
							echo "ADDING [$propvar]=[$propval]\n";
							$dashboards[$n]["dashlets"][$dnum]["opts"][$propvar]=$propval;
							}
						//echo "PROPS:\n";
						//print_r($dashlet["opts"]);
						}
					}
				}
			}
		$n++;
		}
	//print_r($dashboards);
	$dashboardsraw=serialize($dashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	}


function remove_dashlet_from_dashboard($userid=0,$boardid,$dashletid){

	
	// remove this dashlet from the user's dashboard
	$dashboards=get_dashboards($userid);
	$n=0;
	foreach($dashboards as $db){
		if($db["id"]==$boardid){
			echo "FOUND BOARD ID $boardid! [$n]<BR>";
			if(array_key_exists("dashlets",$db)==true){
				$dashlets=$db["dashlets"];
				foreach($dashlets as $dnum => $dashlet){
					if($dashlet["id"]==$dashletid){
						echo "FOUND DASHLET ID $dashletid! [$dnum]<BR>";
						unset($dashboards[$n]["dashlets"][$dnum]);
						}
					}
				}
			}
		$n++;
		}
	//print_r($dashboards);
	$dashboardsraw=serialize($dashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	}

	
function add_dashlet_to_dashboard($userid=0,$boardid,$name,$title,$opts,$args){

	$dashletopts=$opts;
	$dashletargs=$args;
	
	// make sure opts and args are arrays
	if($dashletopts==null)
		$dashletopts=array();
	if($dashletargs==null)
		$dashletargs=array();

	//echo "OPTS: ";
	//print_r($opts);
	//echo "ARGS: ";
	//print_r($args);
	//return;
	
	$thedashlet=array(
		DASHLET_ID => random_string(8),
		DASHLET_NAME => $name,
		DASHLET_TITLE => $title,
		DASHLET_OPTS => $dashletopts,
		DASHLET_ARGS => $dashletargs,
		);
	
	// add this dashlet to the user's dashboard
	$dashboards=get_dashboards($userid);
	$n=0;
	foreach($dashboards as $d){
		if($d["id"]==$boardid){
		
			//echo "FOUND ID $boardid! [$n]<BR>";
			
			// add a dashlets array to the dashboard if necessary
			if(array_key_exists("dashlets",$d)==false)
				$dashboards[$n]["dashlets"]=array();
				
			// auto-position new dashlet (naive layout)
			$dashletcount=count($dashboards[$n]["dashlets"]);
			$left=($dashletcount*100);
			$top=($dashletcount*100);
			$thedashlet[DASHLET_OPTS]["left"]=$left;
			$thedashlet[DASHLET_OPTS]["top"]=$top;
			
			// add the new dashlet to the dashboard
			$dashboards[$n]["dashlets"][]=$thedashlet;
			}
		$n++;
		}
	//print_r($dashboards);
	$dashboardsraw=serialize($dashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	}


////////////////////////////////////////////////////////////////////////
// DASHBOARD FUNCTIONS
////////////////////////////////////////////////////////////////////////

function add_dashboard($userid,$title,$opts,$id=null){

	if(!have_value($title))
		$title="untitled - add_dashboard()";
	//echo "TITLE: $title<BR>";

	$dashboards=get_dashboards($userid);

	if($id==null)
		$id=random_string(8);
	
	$dashboards[]=array(
		"id" => $id,
		"title" => $title,
		"opts" => $opts,
		"dashlets" => array(),
		);
	
	$dashboardsraw=serialize($dashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	return $id;
	}
	
function update_dashboard($userid,$id,$title,$opts){
	$dashboards=get_dashboards($userid);
	
	// fix for empty title
	if($title=="")
		$title="[Untitled]";
	
	$n=0;
	foreach($dashboards as $d){
		if($d["id"]==$id){
			$dashboards[$n]["title"]=$title;
			$dashboards[$n]["opts"]=$opts;
			//echo "<BR>FOUND [$n]!<BR>";
			break;
			}
		$n++;
		}
	//print_r($dashboards);

	$dashboardsraw=serialize($dashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	return true;
	}
	
function get_dashboards($userid){
	$dashboards=array();
	$dashboardsraw=get_user_meta($userid,"dashboards");
	//echo "UID: $userid, RAW: $dashboardsraw<BR>";
	if($dashboardsraw!=null)
		$dashboards=unserialize($dashboardsraw);
	return $dashboards;
	}
	
function is_valid_dashboard_id($userid,$id){
	$d=get_dashboard_by_id($userid,$id);
	if($d==null)
		return false;
	else
		return true;
	}
	
function get_dashboard_by_id($userid,$id){
	$dashboards=get_dashboards($userid);
	foreach($dashboards as $d){
		if($d["id"]==$id)
			return $d;
		}
	return null;
	}
	
function delete_dashboard_id($userid,$id){

	$dashboards=get_dashboards($userid);
	
	// cannot delete home page dashboard
	if($id==HOMEPAGE_DASHBOARD_ID)
		return;

	$i=0;
	foreach($dashboards as $d){
		if($d["id"]==$id){
			//echo "FOUND! [$i]<BR>";
			unset($dashboards[$i]);
			break;
			}
		$i++;
		}
		
	$newdashboards=array();
	foreach($dashboards as $d){
		$newdashboards[]=$d;
		}

	//print_r($newdashboards);

	$dashboardsraw=serialize($newdashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	return true;
	}

	
function clone_dashboard_id($userid,$id,$newtitle){

	$dashboards=get_dashboards($userid);
	
	$i=0;
	$clone=null;
	foreach($dashboards as $d){
		if($d["id"]==$id){
			//echo "FOUND! [$i]<BR>";
			$clone=$dashboards[$i];
			break;
			}
		$i++;
		}
		
	// didn't find the original, so bail
	if($clone==null)
		return false;
		
	// clone gets a new title and id
	$clone["title"]=$newtitle;
	$clone["id"]=random_string(6);
		
	$newdashboards=array();
	$x=0;
	foreach($dashboards as $d){
		$newdashboards[]=$d;
		// add the new dashboard after the one we cloned...
		if($x==$i){
			$newdashboards[]=$clone;
			$x++;
			}
		$x++;
		}

	//print_r($newdashboards);

	$dashboardsraw=serialize($newdashboards);
	set_user_meta($userid,"dashboards",$dashboardsraw,false);
	return true;
	}

	
function get_dashboards_menu_html($userid){
	$ui_path=get_base_url()."dashboards/";
	// get all user dashboards
	$dashboards=get_dashboards($userid);
	//print_r($dashboards);
	$mi=array();
	foreach($dashboards as $d){
		$mi[]=array(
			"type" => "link",
			"title" => $d["title"],
			"opts" => array(
				"href" => $ui_path."dashboard.php?id=".$d["id"],
				"class" => "mydashboardlink",
				"id" => "dashboard-".$d["id"]
				)
			);
		}
	$html=get_menu_items_html($mi);
	return $html;
	}

	
	

////////////////////////////////////////////////////////////////////////
// DASHBOARD DISPLAY FUNCTIONS
////////////////////////////////////////////////////////////////////////

	
// displays all dashlets on a dashboard
function display_dashboard_dashlets($dashboard){
	global $lstr;
	global $dashlets;
	
	if($dashboard==null)
		return;
		
	// add default dashlets to home dashboard
	init_home_dashboard_dashlets();

?>
	<div id="dashboarddashlets">
<?php

	//print_r($dashboard);
	//return;
	$n=0;
	foreach($dashboard["dashlets"] as $index => $dashlet){
		$n++;
		display_dashboard_dashlet($index,$dashlet,$n);
		}

?>
	</div><!--dashboarddashlets-->
<?php
	}
	
	
// displays a single available dashlet
function display_dashboard_dashlet($index,$dashlet,$dashlet_number){
	global $dashlets;
	global $lstr;
	
	//print_r($dashlet);
	//echo "<BR><BR><BR>";
	//return;

	$name=$dashlet[DASHLET_NAME];
	$id=$dashlet[DASHLET_ID];
	$title=$dashlet[DASHLET_TITLE];
	$args=$dashlet[DASHLET_ARGS];
	$opts=$dashlet[DASHLET_OPTS];
	$class="";
	
	
	// TODO - check dashlet perms to make sure this user can see/use the dashlet
	
	
	// TODO - check to make sure all required dashlet components are installed/enabled

	

	// global defaults...
	$w="";
	$h="";
	$z="";
	$o="0.95";
	$t="";
	$l="50";
	$b="";
	
	$cw="";
	$ch="";
	
	// get dashlet defaults
	if(array_key_exists($name,$dashlets)){
		$basedashlet=$dashlets[$name];
		if(array_key_exists(DASHLET_WIDTH,$basedashlet)){
			$w=$basedashlet[DASHLET_WIDTH];
			$cw=$w;
			}
		if(array_key_exists(DASHLET_HEIGHT,$basedashlet)){
			$h=$basedashlet[DASHLET_HEIGHT];
			$cw=$w;
			}
		if(array_key_exists(DASHLET_OPACITY,$basedashlet))
			$o=$basedashlet[DASHLET_OPACITY];
		if(array_key_exists(DASHLET_BACKGROUND,$basedashlet))
			$b=$basedashlet[DASHLET_BACKGROUND];
			
		if(array_key_exists(DASHLET_INBOARD_CLASS,$basedashlet))
			$class=$basedashlet[DASHLET_INBOARD_CLASS];
			
		//echo "<BR><BR>BASE DASHLET<BR>";
		//print_r($basedashlet);
		//return;
		}
	//echo "<BR><BR>DASHLET<BR>";
	//print_r($dashlet);
	//echo "<BR>OPTS<BR>";
	//print_r($opts);
	//return;
		
	// specific dashlet values (saved by user)
	if(array_key_exists("top",$opts))
		$t=$opts["top"];
	if(array_key_exists("left",$opts))
		$l=$opts["left"];
	if(array_key_exists("zindex",$opts))
		$z=$opts["zindex"];
	if(array_key_exists("width",$opts))
		$w=$opts["width"];
	if(array_key_exists("height",$opts))
		$h=$opts["height"];
	if(array_key_exists("opacity",$opts))
		$o=$opts["opacity"];
	if(array_key_exists("background",$opts))
		$b=$opts["background"];
		
	$tpx="";
	$lpx="";
	$wpx="";
	$hpx="";
	if($t!="")
		$tpx=$t."px";
	if($l!="")
		$lpx=$l."px";
	if($w!="")
		$wpx=$w."px";
	if($h!="")
		$hpx=$h."px";
		
	$cw=$wpx;
	$ch=$hpx;
	
	$container_style="top: $tpx; left: $lpx; z-index: $z; width: $cw; height: $ch;";
	$dashlet_style="width: $wpx; height: $hpx; opacity: $o; background: $b;";
	//$dashlet_style="width: $wpx; height: $hpx; background: $b;";
	
	//echo "CONTAINER STYLE: $container_style <BR>";
	//echo "DASHLET STYLE: $dashlet_style <BR>";
	//return;
	
	// is this dashlet pinned?
	$pinned=0;
	$pinclass="";
	if(array_key_exists("pinned",$opts))
		$pinned=$opts["pinned"];
	if($pinned==1)
		$pinclass="dashlet-pinned";
	
	// pass the width and height as args to URL dashlets, so we can size the iframe correctly...
	$args["iframe_width"]=intval($w);
	$args["iframe_height"]=intval($h)-20;  // for good measure, otherwise its a bit too big
	if(intval($args["iframe_width"])<=0)
		$args["iframe_width"]=250;
	if(intval($args["iframe_height"])<=0)
		$args["iframe_height"]=150;
		
?>
	<div class="dashboarddashletcontainer" id="dashletcontainer-<?php echo $id;?>" style="<?php echo $container_style;?>">
	<div class="dashlettitle"><?php echo $title;?></div>
	<div class="dashboarddashletcontrol">
	<div class="dashletpin  <?php echo $pinclass;?>"><a href="#" title="<?php echo $lstr["PinFloatDashletAlt"];?>"></a></div>
	<div class="dashletconfigure"><a href="#" title="<?php echo $lstr["ConfigureDashletAlt"];?>"></a></div>
	<div class="dashletdelete"><a href="#" title="<?php echo $lstr["DeleteDashletAlt"];?>"></a></div>
	</div>
	<div class="dashboarddashlet <?php echo $class;?>" id="dashlet-<?php echo $id;?>" style="<?php echo $dashlet_style;?>">
	<?php display_dashlet($name,$id,$args,DASHLET_MODE_INBOARD);?>
	</div>
	</div>
<?php	
	}

?>