<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: index.php 120 2010-05-28 19:51:56Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();

route_request();

function route_request(){
	global $request;
	
	// add some views if they don't have any
	add_default_views();
	
	// add user's views to views menu
	add_user_views_to_views_menu();
	
	draw_page();
	}

function draw_page(){
	global $lstr;
	
	do_page_start(array("page_title"=>$lstr['ViewsPageTitle']),false);
?>
	<div id="leftnav">
	<?php print_menu(MENU_VIEWS);?>
	</div>
	
	<div id="myviewsinit"></div>
	<div id="myviewsviewtitle">Untitled View</div>

	<div id="maincontent">
	<div id="myviewoverlay"></div>
	<iframe src="<?php echo get_window_frame_url("main.php");?>" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</iframe>
	<div id="viewtools">

	<div id="popout">
	<a href="#"><img src="<?php echo get_base_url();?>/images/popout.png" border="0" alt="<?php echo $lstr['PopoutAlt'];?>" title="<?php echo $lstr['PopoutAlt'];?>"></a>
	</div>

	<div id="trashview">
	<a href="#"><img src="<?php echo get_base_url();?>/images/trash.png" border="0" alt="<?php echo $lstr['DeleteViewAlt'];?>" title="<?php echo $lstr['DeleteViewAlt'];?>"></a>
	</div>

	<div id="editview">
	<a href="#"><img src="<?php echo get_base_url();?>/images/edit.png" border="0" alt="<?php echo $lstr['EditViewAlt'];?>" title="<?php echo $lstr['EditViewAlt'];?>"></a>
	</div>

	<div id="pauseresumeview">
	<a href="#">
	<img border="0" title="<?php echo $lstr['PauseAlt'];?>" alt="<?php echo $lstr['PauseAlt'];?>" src="<?php echo get_base_url();?>/images/pause.png"/>
	</a>	
	</div>

	<div id="myviewspeedslider"></div>

	</div>
	</div>

<?php	
	do_page_end(false);
	}
	
	
function add_user_views_to_views_menu(){

	// get all user views
	$views=get_views(0);
	$x=0;
	foreach($views as $view){

		$x++;
		
		add_menu_item(MENU_VIEWS,array(
			"type" => "link",
			"title" => $view["title"],
			"order" => (200+$x),
			"opts" => array(
				"href" => $view["url"],
				"class" => "myviewlink",
				"id" => "view-".$view["id"]
				)
			));
		}
	}

?>


